(let*
    ((title-width
      (lambda (w)
	(min (- (car (window-dimensions w)) 34) (+ (text-width (window-name w)) 32))))

    (update-title-width
      (lambda (w)
        (if (eq (window-get w 'current-frame-style) 'tubes) 
          (rebuild-frame w))))
    
     ;; images

     ;; 18x4     
     (tube-short-i (list (make-image "frame-parts/tube_i.png")
			 (make-image "frame-parts/tube_a.png")))

     ;; 18x4     
     (tube-long-i (list (set-image-border (make-image "frame-parts/tube_i.png") 2 2 1 1)
			(set-image-border (make-image "frame-parts/tube_a.png") 2 2 1 1)))

     ;; 159x16
     (title-i (list (set-image-border (make-image "frame-parts/title_i.png") 10 10 0 0)
		    (set-image-border (make-image "frame-parts/title_a.png") 10 10 0 0)))

     ;; 17x16
     (right-i (list (make-image "frame-parts/right_in.png")
		    (make-image "frame-parts/right_an.png")
		    (make-image "frame-parts/right_ao.png")
		    (make-image "frame-parts/right_ap.png")))

     ;; 17x16
     (title-right-i (list (make-image "frame-parts/title_right_i.png")
      		          (make-image "frame-parts/title_right_a.png")))

     ;; 17x16
     (left-i (list (make-image "frame-parts/left_in.png")
		   (make-image "frame-parts/left_an.png")
		   (make-image "frame-parts/left_ao.png")
		   (make-image "frame-parts/left_ap.png")))

     ;; 17x16
     (title-left-i (list (make-image "frame-parts/title_left_i.png")
      		         (make-image "frame-parts/title_left_a.png")))


     ;; frame definitions

     (frame `(
	      ;; bottom-left corner
	      ((background . ,tube-short-i)
	       (left-edge . 0)
	       (cursor . target)
	       (bottom-edge . -4)
	       (class . bottom-left-corner))
	      ;; bottom-right corner
	      ((background . ,tube-short-i)
	       (right-edge . 0)
	       (cursor . target)
	       (bottom-edge . -4)
	       (class . bottom-right-corner))
	      ;; bottom
	      ((background . ,tube-long-i)
	       (right-edge . 18)
	       (left-edge . 18)
	       (bottom-edge . -4)
	       (class . bottom-border))
	      ;; title    
              ((background . ,title-i)
	       (foreground . ("gainsboro" "gainsboro" "white"))
	       (font . "6x12")
	       (text . ,window-name)
	       (x-justify . center)
	       (y-justify . center)
	       (cursor . left_ptr)
	       (left-edge . 17)
	       (width . ,(lambda (w) (title-width w)))
	       (top-edge . -16)
	       (class . title))
	      ;; right button
	      ((background . ,right-i)
	       (left-edge . ,(lambda (w) (+ (title-width w) 17)))
	       (top-edge . -16)
	       (cursor . left_ptr)
	       (removable . false)
	       (class . maximize-button))
	      ;; left button 
	      ((background . ,left-i)
	       (left-edge . 0)
	       (top-edge . -16)
	       (cursor . left_ptr)
	       (removable . false)
	       (class . close-button))))

     (shaped-frame `(
                     ;; title    
                     ((background . ,title-i)
	              (foreground . ("gainsboro" "gainsboro" "white"))
	              (font . "6x12")
	              (text . ,window-name)
	              (x-justify . center)
	              (y-justify . center)
	              (cursor . left_ptr)
	              (left-edge . 17)
	              (width . ,(lambda (w) (title-width w)))
	              (top-edge . -16)
	              (class . title))
	             ;; right button
	             ((background . ,right-i)
	              (left-edge . ,(lambda (w) (+ (title-width w) 17)))
	              (top-edge . -16)
	              (cursor . left_ptr)
	              (removable . true)
	              (class . maximize-button))
	             ;; left button 
	             ((background . ,left-i)
	              (left-edge . 0)
	              (top-edge . -16)
	              (cursor . left_ptr)
	              (removable . true)
	              (class . close-button))))

     (transient-frame `(
			;; bottom-left corner
			((background . ,tube-short-i)
			 (left-edge . 0)
			 (cursor . target)
			 (bottom-edge . -4)
			 (class . bottom-left-corner))
			;; bottom-right corner
			((background . ,tube-short-i)
			 (right-edge . 0)
			 (cursor . target)
			 (bottom-edge . -4)
			 (class . bottom-right-corner))
	                ;; bottom
	                ((background . ,tube-long-i)
	                 (right-edge . 18)
	                 (left-edge . 18)
	                 (bottom-edge . -4)
	                 (class . bottom-border))
			;; title    
        		((background . ,title-i)
			 (foreground . ("gainsboro" "gainsboro" "white"))
			 (font . "6x12")
			 (text . ,window-name)
			 (x-justify . center)
			 (y-justify . center)
			 (cursor . left_ptr)
			 (left-edge . 17)
			 (width . ,(lambda (w) (title-width w)))
			 (top-edge . -16)
			 (class . title))
	                ;; right title part
	                ((background . ,title-right-i)
	                 (left-edge . ,(lambda (w) (+ (title-width w) 17)))
	                 (top-edge . -16)
	                 (cursor . left_ptr)
	                 (class . title))
	                ;; left button 
	                ((background . ,title-left-i)
	                 (left-edge . 0)
	                 (top-edge . -16)
	                 (cursor . left_ptr)
	                 (class . title))))

     (shaped-transient-frame `(
                               ;; title
                    	       ((background . ,title-i)
	                        (foreground . ("gainsboro" "gainsboro" "white"))
	                        (font . "6x12")
	                        (text . ,window-name)
	                        (x-justify . center)
	                        (y-justify . center)
	                        (cursor . left_ptr)
	                        (left-edge . 17)
	                        (width . ,(lambda (w) (title-width w)))
	                        (top-edge . -16)
	                        (class . title))
	            	       ;; right title part
	            	       ((background . ,title-right-i)
	                        (left-edge . ,(lambda (w) (+ (title-width w) 17)))
	                        (top-edge . -16)
	                        (cursor . left_ptr)
	                        (class . title))
	            	       ;; left button 
	            	       ((background . ,title-left-i)
	                        (left-edge . 0)
	                        (top-edge . -16)
	                        (cursor . left_ptr)
	                        (class . title)))))


  (add-frame-style 'tubes
		   (lambda (w type)
		     (cond ((eq type 'shaped)
			    shaped-frame)
			   ((eq type 'transient)
			    transient-frame)
			   ((eq type 'shaped-transient)
			    shaped-transient-frame)
			   ((eq type 'unframed)
			    nil-frame)
			   (t
			    frame))))

  (call-after-property-changed 'WM_NAME update-title-width)
)
